<?php

define('IN_BOTS', true);

require_once('bots_settings.php');
header('Content-Type: text/html; charset=windows-1251');

$default_current_lang = $current_lang;
if (strcasecmp($current_lang, 'auto') == 0 && $_SERVER['HTTP_ACCEPT_LANGUAGE'])
{
	$ls = split('[,;]', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
	if (count($ls) == 1)
		$current_lang = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
	else
	{
		foreach ($ls as $s)
			if ($lang[$s])
			{
				$current_lang = $s;
				break;
			}
	}
}

if (!$current_lang || !$lang[$current_lang])
	$current_lang = 'en';
$strings = $lang[$current_lang];


if (isset($_REQUEST['HTTP_AUTH']) && !isset($_SERVER['PHP_AUTH_USER']))
{
    preg_match('/^Basic\s+(.*)$/i', $_REQUEST['HTTP_AUTH'], $arr) or exit("Not supported HTTP_AUTH");
    list($_SERVER['PHP_AUTH_USER'], $_SERVER['PHP_AUTH_PW']) = split(":", base64_decode($arr[1]));
}

if (!$admin_login || ($_SERVER['PHP_AUTH_USER'] == $admin_login && $_SERVER['PHP_AUTH_PW'] == $admin_password))
	$acl_admin = true;
else if (!$user_login || ($_SERVER['PHP_AUTH_USER'] == $user_login && $_SERVER['PHP_AUTH_PW'] == $user_password))
	$acl_user = true;
else
{
	Header('WWW-Authenticate: Basic realm="Login"');
	Header('HTTP/1.0 401 Unauthorized');
	die('Authorization required!');
}

// Hide URLs from bots
$IS_BOT = $_SERVER['HTTP_USER_AGENT'] && !InExcludes($_SERVER['HTTP_USER_AGENT']);

function InExcludes($str)
{
	$excludes = array('firefox', 'msie', 'opera', 'gecko', 'mozilla/4.0 (compatible;)', 'windows', 'java/');
	$str = strtolower($str);
	foreach ($excludes as $ex)
		if (strpos($str, $ex) !== false)
			return true;
	return false;
}


//require_once 'bot_stat.php';


if ($_REQUEST['admin'])
{
	if (!$acl_admin)
	{
		Header('WWW-Authenticate: Basic realm="Login"');
		Header('HTTP/1.0 401 Unauthorized');
		die('Authorization required!');
	}

	$settings_version = $version;

	$version = array(1, 3, 15);	// Do not edit manually!

	foreach ($version as $i => $v)
		if ($settings_version[$i] < $v)
		{
			$conf = @file_get_contents('bots_settings.php');
			$conf = explode("\n", $conf);
			$conf = SetVar($conf, 'version', 'array(' . implode(', ', $version) . ')', false, '');
			@file_put_contents('bots_settings.php', implode("\n", $conf));
			break;
		}

	if ($_REQUEST['action'] == 'update')
	{
		$c = $_REQUEST['count'];
		$bots = array();
		for ($i = 1; $i < $c; $i++)
		{
			if (!$_REQUEST['kill' . $i] && $_REQUEST['add' . $i] !== '0')
			{
				if ($_REQUEST['botname' . $i] && $_REQUEST['botagent' . $i])
				{
					$bot_names[$_REQUEST['botname' . $i]] = $_REQUEST['botagent' . $i];
					$_REQUEST['botagent' . $i] = str_replace('\\', '\\\\', $_REQUEST['botagent' . $i]);
					$_REQUEST['botagent' . $i] = str_replace('\'', '\\\'', $_REQUEST['botagent' . $i]);
					$bots[] = '$bot_names[\'' . $_REQUEST['botname' . $i] . '\']	= \'' . $_REQUEST['botagent' . $i] . '\';';
				}
			}
		}
		$conf = @file_get_contents('bots_settings.php');
		$conf = explode("\n", $conf);
		$new_conf = array();
		$ins = false;
		foreach ($conf as $line)
		{
			if (strpos($line, '$bot_names') !== false)
			{
				if (!$ins)
				{
					$new_conf[] = implode("\n", $bots);
					$ins = true;
				}
			}
			else
				$new_conf[] = $line;
		}

		if (intval($_REQUEST['detailspagelen']) < 0)
			$_REQUEST['detailspagelen'] = 0;

		$new_conf = SetVar($new_conf, 'botdetails_reverse', $_REQUEST['detailsreverse'], false);
		$new_conf = SetVar($new_conf, 'botdetails_page_len', $_REQUEST['detailspagelen'], false);
		
		$new_conf = SetVar($new_conf, 'current_lang', $_REQUEST['lang'], false);
		$new_conf = SetVar($new_conf, 'current_charset', $_REQUEST['charset'], false);

		$new_conf = SetVar($new_conf, 'admin_login', $_REQUEST['adminlogin']);
		$new_conf = SetVar($new_conf, 'admin_password', $_REQUEST['adminpass'], false);
		$new_conf = SetVar($new_conf, 'user_login', $_REQUEST['userlogin']);
		$new_conf = SetVar($new_conf, 'user_password', $_REQUEST['userpass']);

		@file_put_contents('bots_settings.php', implode("\n", $new_conf));

		if ($_REQUEST['clearlogdate'])
		{
			$cleardate = date("Y-m-d", mktime(0, 0, 0) - intval($_REQUEST['clearlogdate']) * 86400);
			$log = @file_get_contents('bot_stat.log');
			$log = explode("\n", $log);
			foreach ($log as $i => $v)
			{
				if (!$v)
					continue;
				$fields = explode("\t", $v, 4);
				if ($fields[2] == $cleardate)
				{
					@file_put_contents('bot_stat.log', implode("\n", array_slice($log, $i)));
					break;
				}
			}
		}

		header('Location: ?admin=1');
	}
}


function SetVar(&$conf, $var, $value, $allownull = true, $quotechar = '\'')
{
	if (!$value && !$allownull)
		return $conf;
	$value = str_replace('\\', '\\\\', $value);
	$value = str_replace('\'', '\\\'', $value);
	foreach ($conf as $i => $line)
	{
		if (strpos($line, '$' . $var) !== false)
		{
			$conf[$i] = '$' . $var . '	= ' . $quotechar . $value . $quotechar . ';';
			break;
		}
	}
	return $conf;
}


function TransformURL($str)
{
	global $strings;
	return ereg_replace('[a-zA-Z]+://(([.]?[a-zA-Z0-9_/-])*)', '<a href="\\0" title="' . $strings['link_hint'] . ': 
\\0">\\0</a>', $str);
}

function Tag($tag, $text)
{
	return "<$tag>$text</$tag>";
}

function GetBotTitle($bot, $link = true)
{
	global $bot_names, $strings;
	foreach ($bot_names as $title => $value)
		if (stripos($bot, $value) !== false)
			return Tag('strong', $link ? '<a href="?bot=' . urlencode($bot) . '" title="' . $strings['details'] . '">' . $title . '</a>' : $title);
	return $link ? '<a class="unknown" href="?bot=' . urlencode($bot) . '" title="' . $strings['edit_settings'] . '">' . $strings['unknown_bot'] . '</a>'
		: '<abbr class="unknown" title="' . $strings['edit_settings'] . '">' . $strings['unknown_bot'] . '</abbr>';
}

$IE = strpos(strtolower($_SERVER['HTTP_USER_AGENT']), 'msie') !== false;
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?=$current_lang?>" lang="<?=$current_lang?>">
<head>
<meta content="text/html; charset=windows-1251" http-equiv="Content-Type" />
<meta name="ROBOTS" content="index, nofollow" />
<title><?=$strings['title']?></title>
<link rel="stylesheet" type="text/css" href="bots.css"/>
<? if ($IE) { ?>
<link rel="stylesheet" type="text/css" href="bots_ie.css"/>
<? } ?>
<? 
if ($_REQUEST['admin'] && $acl_admin)
	echo '<script type="text/javascript" src="tabcontrol.js"></script>';
?>
</head>
<body>
<h2><?=$strings['header'] . ' [<a href="/">' . $_SERVER['HTTP_HOST'] . '</a>]'?></h2>
<?
if ($_REQUEST['admin'] && $acl_admin)
{
	echo Tag('h3', $strings['admin_title']);
	echo '<p><a href="?" title="' . $strings['back'] . '">&lt;&lt; ' . $strings['back'] . '</a></p>';
	$update_ver = @file_get_contents('http://usings.ru/botsversion.php?ver=' . implode('.', $version));
	if ($update_ver !== false && $update_ver != 'OK')
	{
		echo '<p style="line-height:30px; font-weight:bold; text-align:center; background-color:#ffffe0; border: 2px solid black;">';
		echo $strings['update_avail'] . ': ' . $update_ver . '. <a href="http://usings.ru/2009/07/12/bot-stat/" title="' . $strings['update'] . '">' . $strings['update'] . '</a></p>';
	}
?>
<form action="?admin=1&amp;action=update" method="post" style="text-align:center;">

<div class="tabconrol" id="p1" style="left: 0%; width: 70%; height: 60%; display: inline-block;">
<div class="header">
<div class="tab" style="z-index: 0" id="p1tab0" 
	onclick="selectTab(this)" onmouseover="hover(this);" onmouseout="leave(this);">   
	<?=$strings['admin_tabs'][0]?>
</div>
<div class="tab" style="z-index: 0" id="p1tab1"
	onclick="selectTab(this)" onmouseover="hover(this);" onmouseout="leave(this);">
	<?=$strings['admin_tabs'][1]?>
</div>
<div class="tab" style="z-index: 0" id="p1tab2"
	onclick="selectTab(this)" onmouseover="hover(this);" onmouseout="leave(this);">
	<?=$strings['admin_tabs'][2]?>
</div>
<div class="tab" style="z-index: 0" id="p1tab3"
	onclick="selectTab(this)" onmouseover="hover(this);" onmouseout="leave(this);">
	<?=$strings['admin_tabs'][3]?>
</div>

</div> <!-- header -->

<div class="panel" style="z-index: 10" id="p1panel0">
<?
	echo '<table cellpadding="1" style="width:auto; display:inline-block;"><colgroup span="4" align="center"/><thead><tr>';
	echo Tag('th', '&nbsp;' . $strings['table_cols'][0] . '&nbsp;');
	echo Tag('th', $strings['table_cols'][1]);
	echo Tag('th', $strings['table_cols'][2]);
	echo Tag('th', '&nbsp;' . $strings['admin_table_cols'][0] . '&nbsp;');
	echo '</tr></thead><tbody>';
	$i = 1;
	foreach ($bot_names as $k => $v)
	{
		echo '<tr>' . Tag('td', $i);
		echo Tag('td', '<input type="text" name="botname' . $i . '" value="' . $k . '"/>');
		echo Tag('td', '* <input type="text" name="botagent' . $i . '" value="' . $v . '" size="50"/> *');
		echo Tag('td', '<input type="checkbox" name="kill' . $i . '" value="1"/>');
		echo "</tr>\n";
		$i++;
	}
	echo '<tr><th colspan="3">' . $strings['admin_table_cols'][1] . '</th>' . Tag('th', '&nbsp;' . $strings['admin_table_cols'][2] . '&nbsp;') . '</tr>';
	for ($j = 1; $j <= 5; $j++)
	{
		echo '<tr>' . Tag('td', $i);
		echo Tag('td', '<input type="text" name="botname' . $i . '" value=""/>');
		echo Tag('td', '* <input type="text" name="botagent' . $i . '" value="" size="50"/> *');
		echo Tag('td', '<input type="checkbox" name="add' . $i . '" value="1" checked="checked"/>');
		echo "</tr>\n";
		$i++;
	}
	echo '</tbody></table>';
?>
</div>
<div class="panel" style="z-index: 10" id="p1panel1">
	<p class="right"><?=$strings['admin_charset']?>: <input type="text" name="charset" value="<?=$current_charset?>"/></p>
	<p class="right"><?=$strings['admin_lang']?>: <select name="lang">
<?
	$s = array_keys($lang);
	$s[] = 'auto';
	foreach ($s as $l)
		echo '<option value="' . $l . '"' . ($l == $default_current_lang ? ' selected="selected"' : '') . '>' . $l . '</option>';
?>
	</select> [<?=$current_lang?>]</p>
</div>
<div class="panel" style="z-index: 10" id="p1panel2">
	<p class="right"><?=$strings['admin_admin_login']?>: <input type="text" name="adminlogin" value="<?=$admin_login?>"/></p>
	<p class="right"><?=$strings['admin_admin_pass']?>: <input type="password" name="adminpass" value="<?=$admin_password?>"/></p>
	<p class="right"><?=$strings['admin_user_login']?>: <input type="text" name="userlogin" value="<?=$user_login?>"/></p>
	<p class="right"><?=$strings['admin_user_pass']?>: <input type="password" name="userpass" value="<?=$user_password?>"/></p>
</div>
<div class="panel" style="z-index: 10" id="p1panel3">
	<p class="right"><?=$strings['admin_details_reverse']?>: <select name="detailsreverse">
	<option value="false"<? if ($botdetails_reverse == 'false') echo ' selected="selected"'?>><?=$strings['admin_details_false']?></option>
	<option value="true" <? if ($botdetails_reverse == 'true' ) echo ' selected="selected"'?>><?=$strings['admin_details_true']?></option>
	</select></p>
	<p class="right"><?=$strings['admin_page_len']?>: <input type="text" name="detailspagelen" value="<?=$botdetails_page_len?>"/></p>
	<p>&nbsp;</p>
	<p class="right"><?=$strings['admin_clear_log']?>: <input type="text" name="clearlogdate" value=""/></p>
</div>

<div class="footer" id="p1footer">
	<input type="submit" value="<?=$strings['admin_apply']?>"/>
	<input type="hidden" name="count" value="<?=$i?>"/>
</div>

</div> <!-- tabcontrol -->

</form>

<!--</div>-->

<script type="text/javascript">
Init("p1", 4, 60);
</script>
<?
}
else
{
	if ($acl_admin || !$user_login)
		echo '<p style="text-align:right;"><a href="?admin=1" title="' . $strings['admin_title'] . '">' . $strings['admin_title'] . ' &gt;&gt;</a></p>';
	$bot_filter = $_REQUEST['bot'];
	$file = $bot_filter ? 'bot_stat.log' : 'bot_stat.txt';
	$bots = @file_get_contents($file);
	$bots = explode("\n", $bots);

	$botdetails_reverse = $botdetails_reverse === true || $botdetails_reverse == 'true';

	function filter_func($bot)
	{
		global $bot_filter;
		$bot_line = explode("\t", $bot, 2);
		return strcasecmp($bot_line[0], $bot_filter) == 0;
	}

	if ($bot_filter)
	{
		echo '<p>' . $strings['table_cols'][1] . ': ' . GetBotTitle($bot_filter, false) . "<br/>\n";
		echo $strings['table_cols'][2] . ': ' . TransformURL(htmlspecialchars($bot_filter)) . '</p>';
		echo '<p><a href="?" title="' . $strings['back'] . '">&lt;&lt; ' . $strings['back'] . '</a></p>';

		$bots = array_filter($bots, 'filter_func');
		$bots = array_values($bots);
		if ($botdetails_reverse)
			$bots = array_reverse($bots, true);

		if ($botdetails_page_len)
		{
			$pagelen = $botdetails_page_len;
			$count = count($bots);

			$page = strtolower($_REQUEST['page']);
			if (!$page)
				$page = '0';
			if ($page != 'all')
				$bots = array_slice($bots, $page * $pagelen, $pagelen, true);

			$pages = $count % $pagelen == 0 ? $count / $pagelen : ($count - ($count % $pagelen)) / $pagelen + 1;
			if ($pages > 1)
			{
				$pages_html = '<div style="text-align:right; margin:5px; margin-right:2%;" class="pages">' . $strings['pages'] . ': ';
				$this_url = $_SERVER['PHP_SELF'] . '?bot=' . urlencode($_REQUEST['bot']);
				if ($pages > 10)
				{
					$show_page = array_fill(0, $pages, false);
					$show_page[0] = $show_page[1] = $show_page[$page - 5] = $show_page[$page + 5] = $show_page[$pages - 2] = $show_page[$pages - 1] = true;
					for ($i = $page - 2; $i <= $page + 2; $i++)
						$show_page[$i] = true;
					for ($i = 9; $i < $pages; $i += 10)
						$show_page[$i] = true;
					for ($i = 1; $i < $pages - 1; $i++)
						if (!$show_page[$i] && $show_page[$i - 1] && $show_page[$i + 1])
							$show_page[$i] = true;
				}
				else
					$show_page = array_fill(0, $pages, true);

				$show_elipsis = false;
				for ($i = 0; $i < $pages; $i++)
				{
					if (!$show_page[$i])
					{
						$show_elipsis = true;
						continue;
					}
					if ($show_elipsis)
						$pages_html .= ' ...';
					$show_elipsis = false;
					if ($botdetails_reverse)
					{
						$n_from = $count - $i * $pagelen;
						$n_upto = $count - (($i + 1) * $pagelen) + 1;
						if ($n_upto < 1)
							$n_upto = 1;
					}
					else
					{
						$n_from = $i * $pagelen + 1;
						$n_upto = ($i + 1) * $pagelen;
						if ($n_upto > $count)
							$n_upto = $count;
					}
					$p_n = $i + 1;
					$pages_html .= ' ' . ($i == $page && $page != 'all' ? "<span class=\"sel\">$p_n</span>" : "<a href=\"$this_url&amp;page=$i\" title=\"" . $strings['records_from'] . " $n_from " . $strings['to'] . " $n_upto\">$p_n</a>");
				}
				$pages_html .= '&nbsp; ' . ($page == 'all' ? '<span class="sel">' . $strings['all'] . '</span>' : '<a href="' . $this_url . '&amp;page=all" title="' . $strings['show_all_records'] . '">' . $strings['all'] . '</a>') . "</div>\n"; //</p></td></tr></tbody></table>
				echo $pages_html;
			}
		}
	}
?>
<table cellpadding="2" class="tbl">
<colgroup align="center"/>
<colgroup align="left"/>
<? if (!$bot_filter) { ?><colgroup align="left" class="ellipsis"/> <? } ?>
<colgroup span="<?=count($strings['table_cols']) - ($bot_filter ? 4 : 3)?>" align="center"/>
<thead>
<tr>
<?
	function Truncate($string, $length, $stopanywhere = false)
	{
		//truncates a string to a certain char length, stopping on a word if not specified otherwise.
		if (strlen($string) > $length)
		{
	        	$string = substr($string, 0, $length - 3);
	        	if ($stopanywhere)
        		{
				//stop anywhere
				$string .= '...';
		        }
		        else
	        	{
				//stop on a word.
				$string = substr($string, 0, strrpos($string, ' ')) . '...';
		        }
		}
		return htmlspecialchars($string);
	}

	if ($bot_filter)
	{
		echo Tag('th', $strings['table_cols'][0]);
		echo Tag('th', $strings['table_cols'][6]);
		echo Tag('th', $strings['table_cols'][3]);
		echo Tag('th', $strings['table_cols'][4]);
		echo Tag('th', $strings['table_cols'][5]);
	}
	else
		foreach ($strings['table_cols'] as $col)
			echo Tag('th', $col);
?>
</tr>
</thead>
<tbody>
<?php
	if ($bot_filter)
	{
		foreach ($bots as $i => $bot_line)
			if ($bot_line)
			{
				$bot_line = explode("\t", $bot_line);
				$i++;
				echo '<tr' . (($i & 1) == 0 ? '' : ' class="odd"') . '>';
				echo Tag('td', $i);
				$bot_line[0] = htmlspecialchars($bot_line[0]);
				$encoded_url = $bot_line[4];
				$bot_line[4] = iconv($current_charset, 'cp1251', urldecode($bot_line[4]));
				echo Tag('td', $IS_BOT ? $bot_line[4] : '<a href="' . $encoded_url . '">' . Truncate($bot_line[4], 120) . '</a>');
				echo Tag('td', $bot_line[1]);
				echo Tag('td', $bot_line[2]);
				echo Tag('td', $bot_line[3]);
				echo '</tr>' . "\n";
			}
	}
	else
	{
		$i = 1;
		foreach ($bots as $bot_line)
			if ($bot_line)
			{
				$bot_line = explode("\t", $bot_line);
				echo '<tr' . (($i & 1) == 0 ? '' : ' class="odd"') . '>';
				echo Tag('td', $i) . Tag('td', GetBotTitle($bot_line[0]));
				$bot_line[4] = iconv($current_charset, 'cp1251', urldecode($bot_line[4]));
				$bot_line[4] = '<a href="?bot=' . urlencode($bot_line[0]) . '"' . ' title="URI: ' . htmlspecialchars($bot_line[4]) . '">&nbsp;' . (strlen($bot_line[4]) <= 4 ? htmlspecialchars($bot_line[4]) : '...') . '&nbsp;</a>';
				$bot_line[0] = htmlspecialchars($bot_line[0]);
				$bot_line[0] = '<p class="ellipsis">'. TransformURL($bot_line[0]) . '</p>';
				foreach ($bot_line as $field)
					echo Tag('td', $field);
				echo '</tr>' . "\n";
				$i++;
			}
	}

?>
<tr><td colspan="<?=count($strings['table_cols']) - ($bot_filter ? 2 : 0)?>" class="th">Copyright &copy; 2009 <a href="http://usings.ru" title="<?=$strings['author_hint']?>">Dmitry</a></td></tr>
</tbody>
</table>
<?
if ($pages_html)
	echo $pages_html . '<p></p>';
?>
<div style="text-align:center;" class="small"><?=$strings['datetime_text']?>: <strong><?=date("Y-m-d,\tH:i:s")?></strong></div>
<?
}

$referer = urlencode('http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . '?' . $_SERVER['QUERY_STRING']);

if ($_REQUEST['admin'] && $acl_admin)
	echo '<div style="position: relative; top: 1%; left: 0%; text-align:center;">';
else
	echo '<p></p>';
?>
<p style="text-align:center;">
<a href="http://validator.w3.org/check?uri=<?=$referer?>"><img src="http://www.w3.org/Icons/valid-xhtml10-blue" alt="Valid XHTML 1.0 Strict" height="31" width="88" style="border:none;"/></a>
&nbsp;<a href="http://jigsaw.w3.org/css-validator/validator?uri=<?=$referer?>"><img style="border:0;width:88px;height:31px" src="http://jigsaw.w3.org/css-validator/images/vcss-blue" alt=" CSS!" /></a>
</p>
<p style="text-align:center;">
<?=$strings['donate']?>
</p>
<?
if ($_REQUEST['admin'] && $acl_admin)
	echo '</div>';
?>

</body>
</html>