<?php

function bencode($var) {
    if (is_string($var)) {
        return strlen($var) . ':' . $var;
    } else if (is_int($var)) {
        return 'i' . $var . 'e';
    } else if (is_float($var)) {
        return 'i' . sprintf('%.0f', $var) . 'e';
    } else if (is_array($var)) {
        if (count($var) == 0) {
            return 'de';
        } else {
            $assoc = false;

            foreach ($var as $key => $val) {
                if (!is_int($key)) {
                    $assoc = true;
                    break;
                }
            }

            if ($assoc) {
                ksort($var, SORT_REGULAR);
                $ret = 'd';

                foreach ($var as $key => $val) {
                    $ret .= bencode($key) . bencode($val);
                }
                return $ret . 'e';
            } else {
                $ret = 'l';

                foreach ($var as $val) {
                    $ret .= bencode($val);
                }
                return $ret . 'e';
            }
        }
    } else {
        trigger_error('bencode error: wrong data type', E_USER_ERROR);
    }
}


echo "--- <br>";

$fp = fsockopen("udp://93.66.66.205", 53606, $errno, $errstr, 10);
flush();
if (!$fp) {
    echo "$errstr ($errno)<br />\n";
} else {
//{"t":"aa", "y":"q", "q":"ping", "a":{"id":"abcdefghij0123456789"}}
//c519f93421ae40069805b6b7e46019bd0d382b26
    $data = array(
        't' => 'aa',
        'y' => 'q',
        'q' => 'ping',
        'a' => array(
            'id' => 'c519f93421ae40069805b6b7e46019bd0d382b26'
            ));

    $out = bencode($data);
    fwrite($fp, $out);
    while (!feof($fp)) {
        echo fgets($fp, 1280);
        flush();
    }
    fclose($fp);
}

/*
*/
echo "<br>--- ";
?>



<table border="1">
<?
$dir = scandir("./");

foreach ($dir as $k => $d) {
    if (($d != ".") and ($d != "..") and ($d != "") and ($d != "view.php")) {



        $file = unserialize(implode("", file("./" . $d)));


        echo "<tr><td><pre>";
        print_r($file);
        echo "</pre>";


        echo "<br><br><br><br>";




        echo "</td></tr>";
    }
}
die();
?>
</table>