<?php
if (! defined ( 'IN_ANNOUNCE' ))
    die ( 'Hacking attempt!' );
require_once ($rootpath . 'include/config.php');
require_once ($rootpath . 'include/secrets.php');
function benc_resp($d) {
	benc_resp_raw ( benc ( array (
		type => "dictionary", 
		value => $d ) ) );
}

function benc_resp_raw($x) {
	@header ( "Content-Type: text/plain" );
	@header ( "Pragma: no-cache" );
	print ( $x );
}

function err($msg) {
	benc_resp ( array (
		"failure reason" => array (
			type => "string", 
			value => $msg ) ) );
	exit ();
}

function get_date_time($timestamp = 0) {
	if ($timestamp)
		return date ( "Y-m-d H:i:s", $timestamp );
	else
		return date ( "Y-m-d H:i:s" );
}

function gmtime() {
	return strtotime ( get_date_time () );
}

function strip_magic_quotes($arr) {
	foreach ( $arr as $k => $v ) {
		if (is_array ( $v )) {
			$arr [$k] = strip_magic_quotes ( $v );
		} else {
			$arr [$k] = stripslashes ( $v );
		}
	}
	
	return $arr;
}

function mksize($bytes) {
	if ($bytes < 1000 * 1024)
		return number_format ( $bytes / 1024, 2 ) . " kB";
	elseif ($bytes < 1000 * 1048576)
		return number_format ( $bytes / 1048576, 2 ) . " MB";
	elseif ($bytes < 1000 * 1073741824)
		return number_format ( $bytes / 1073741824, 2 ) . " GB";
	else
		return number_format ( $bytes / 1099511627776, 2 ) . " TB";
}

function emu_getallheaders() {
	foreach ( $_SERVER as $name => $value )
		if (substr ( $name, 0, 5 ) == 'HTTP_')
			$headers [str_replace ( ' ', '-', ucwords ( strtolower ( str_replace ( '_', ' ', substr ( $name, 5 ) ) ) ) )] = $value;
	return $headers;
}

function portblacklisted($port) {
	if ($port >= 411 && $port <= 413)
		return true;
	if ($port >= 6881 && $port <= 6889)
		return true;
	if ($port == 1214)
		return true;
	if ($port >= 6346 && $port <= 6347)
		return true;
	if ($port == 4662)
		return true;
	if ($port == 6699)
		return true;
	return false;
}

function validip($ip) {
	if (! empty ( $ip ) && $ip == long2ip ( ip2long ( $ip ) )) {
		$reserved_ips = array (
			array (
				'0.0.0.0', 
				'2.255.255.255' ), 
			array (
				'10.0.0.0', 
				'10.255.255.255' ), 
			array (
				'127.0.0.0', 
				'127.255.255.255' ), 
			array (
				'169.254.0.0', 
				'169.254.255.255' ), 
			array (
				'172.16.0.0', 
				'172.31.255.255' ), 
			array (
				'192.0.2.0', 
				'192.0.2.255' ), 
			array (
				'192.168.0.0', 
				'192.168.255.255' ), 
			array (
				'255.255.255.0', 
				'255.255.255.255' ) );
		
		foreach ( $reserved_ips as $r ) {
			$min = ip2long ( $r [0] );
			$max = ip2long ( $r [1] );
			if ((ip2long ( $ip ) >= $min) && (ip2long ( $ip ) <= $max))
				return false;
		}
		return true;
	} else
		return false;
}

function getip() {
	if (isset ( $_SERVER )) {
		if (isset ( $_SERVER ['HTTP_X_FORWARDED_FOR'] ) && validip ( $_SERVER ['HTTP_X_FORWARDED_FOR'] )) {
			$ip = $_SERVER ['HTTP_X_FORWARDED_FOR'];
		} elseif (isset ( $_SERVER ['HTTP_CLIENT_IP'] ) && validip ( $_SERVER ['HTTP_CLIENT_IP'] )) {
			$ip = $_SERVER ['HTTP_CLIENT_IP'];
		} else {
			$ip = $_SERVER ['REMOTE_ADDR'];
		}
	} else {
		if (getenv ( 'HTTP_X_FORWARDED_FOR' ) && validip ( getenv ( 'HTTP_X_FORWARDED_FOR' ) )) {
			$ip = getenv ( 'HTTP_X_FORWARDED_FOR' );
		} elseif (getenv ( 'HTTP_CLIENT_IP' ) && validip ( getenv ( 'HTTP_CLIENT_IP' ) )) {
			$ip = getenv ( 'HTTP_CLIENT_IP' );
		} else {
			$ip = getenv ( 'REMOTE_ADDR' );
		}
	}
	
	return $ip;
}

function dbconn () {
	global $mysql_host, $mysql_user, $mysql_pass, $mysql_db;
	if (! @mysql_connect ( $mysql_host, $mysql_user, $mysql_pass )) {
		err ( 'dbconn: mysql_connect: ' . mysql_error () );
	}
	mysql_select_db ( $mysql_db ) or err ( 'dbconn: mysql_select_db: ' + mysql_error () );
	register_shutdown_function ( "mysql_close" );
}

function sqlesc($value) {

	if (! is_numeric ( $value )) {
		$value = "'" . mysql_real_escape_string ( $value ) . "'";
	}
	return $value;
}

function hash_pad($hash) {
	return str_pad ( $hash, 20 );
}

function hash_where($name, $hash) {
	$shhash = preg_replace ( '/ *$/s', "", $hash );
	return "($name = " . sqlesc ( $hash ) . " OR $name = " . sqlesc ( $shhash ) . ")";
}

function unesc($x) {
	if (get_magic_quotes_gpc ())
		return stripslashes ( $x );
	return $x;
}

function gzip() {
	if (@extension_loaded ( 'zlib' ) && @ini_get ( 'zlib.output_compression' ) != '1' && @ini_get ( 'output_handler' ) != 'ob_gzhandler') {
		@ob_start ( 'ob_gzhandler' );
	}
}

function sql_error() {
	global $annerr;
	if ($annerr)
		return mysql_error ();
}
?>
